require "spec_helper"
require "simple_ca/ca"

describe SimpleCA::CA do
  describe "#sign_csr" do
    let(:cert) { double :certificate }
    let(:root) { double :root }
    let(:key) { double :key }
    let(:signer) { double :signer }
    let(:csr) { double :csr }

    subject { described_class.new(root, key) }

    before do
      allow(SimpleCA::SignCSR).to receive(:new).with(root, key) { signer }
      allow(signer).to receive(:call).with(csr) { cert }
    end

    it "generates a certificate from the CSR" do
      expect(subject.sign_csr csr).to eq cert
    end
  end
end
